#!/usr/bin/perl

#┌─────────────────────────────────
#│ CLIP BOARD : admin.cgi - 2022/06/26
#│ copyright (c) kentweb, 1997-2022
#│ https://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  ClipBoard v6.21 com-multi v2.0 : admin.cgi - 2023/10/17
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
cgi_err('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 処理分岐
if ($in{data_men}) { data_men(); }
if ($in{pass_mgr}) { pass_mgr(); }

# メニュー画面
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	print <<EOM;
<div id="main">
<div class="menu-msg">選択ボタンを押してください。</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="form-tbl02">
<tr>
	<th>選択</th>
	<th width="280">処理メニュー</th>
</tr><tr>
	<td><input type="submit" name="data_men" value="選択"></td>
	<td>記事データ管理</td>
</tr><tr>
	<td><input type="submit" name="pass_mgr" value="選択"></td>
	<td>パスワード管理</td>
</tr><tr>
	<td><input type="button" class="button" value="選択" onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>掲示板へ戻る</td>
</tr><tr>
	<td><input type="submit" name="logoff" value="選択"></td>
	<td>ログアウト</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  データ管理
#-----------------------------------------------------------
sub data_men {
	# 編集フォーム
	if ($in{mode_edit} && $in{no}) {
		my $log;
		open(DAT,"$cf{datadir}/log.cgi") or cgi_err("open err: log.cgi");
		while (<DAT>) {
			my ($no) = (split(/<>/))[0];
			
			if ($in{no} == $no) {
				$log = $_;
				last;
			}
		}
		close(DAT);
		
		# フォーム
		edit_form($log);
	
	# 編集実行
	} elsif ($in{mode_edit2} && $in{no}) {
		
		if ($in{url} eq 'http://') { $in{url} = ''; }

		# 画像アップ
		my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n);
		if ($in{upfile1} || $in{upfile2} || $in{upfile3}) {
			($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n) = upload($in{no});
		}
		
		my @log;
		open(DAT,"+< $cf{datadir}/log.cgi") or cgi_err("open err: log.cgi");
		eval "flock(DAT,2);";
		while (<DAT>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$host,$pw,$ex1,$w1,$h1,$tim,$chk,$col,$col2,$ex2,$w2,$h2,$ex3,$w3,$h3,$ex4,$w4,$h4,$ex5,$w5,$h5,$ex6,$w6,$h6,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$lock) = split(/<>/);
			
			if ($in{no} == $no) {

				# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{imgdir}/$no-1$ex1");
					unlink("$cf{imgdir}/$no-s-1$ex1") if (-f "$cf{imgdir}/$no-s-1$ex1");
					$ex1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{imgdir}/$no-2$ex2");
					unlink("$cf{imgdir}/$no-s-2$ex2") if (-f "$cf{imgdir}/$no-s-2$ex2");
					$ex2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{imgdir}/$no-3$ex3");
					unlink("$cf{imgdir}/$no-s-3$ex3") if (-f "$cf{imgdir}/$no-s-3$ex3");
					$ex3 = $w3 = $h3 = "";
				}
				if ($in{del4}) {
					unlink("$cf{imgdir}/$no-4$ex4");
					unlink("$cf{imgdir}/$no-s-4$ex4") if (-f "$cf{imgdir}/$no-s-4$ex4");
					$ex3 = $w3 = $h3 = "";
				}
				if ($in{del5}) {
					unlink("$cf{imgdir}/$no-5$ex5");
					unlink("$cf{imgdir}/$no-s-5$ex5") if (-f "$cf{imgdir}/$no-s-5$ex5");
					$ex3 = $w3 = $h3 = "";
				}
				if ($in{del6}) {
					unlink("$cf{imgdir}/$no-6$ex6");
					unlink("$cf{imgdir}/$no-s-6$ex6") if (-f "$cf{imgdir}/$no-s-6$ex6");
					$ex3 = $w3 = $h3 = "";
				}

				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $ex1) {
					unlink("$cf{imgdir}/$no-1$ex1");
					unlink("$cf{imgdir}/$no-s-1$ex1") if (-f "$cf{imgdir}/$no-s-1$ex1");
				}
				if ($e2n && $e2n ne $ex2) {
					unlink("$cf{imgdir}/$no-2$ex2");
					unlink("$cf{imgdir}/$no-s-2$ex2") if (-f "$cf{imgdir}/$no-s-2$ex2");
				}
				if ($e3n && $e3n ne $ex3) {
					unlink("$cf{imgdir}/$no-3$ex3");
					unlink("$cf{imgdir}/$no-s-3$ex3") if (-f "$cf{imgdir}/$no-s-3$ex3");
				}
				if ($e4n && $e4n ne $ex4) {
					unlink("$cf{imgdir}/$no-4$ex4");
					unlink("$cf{imgdir}/$no-s-4$ex4") if (-f "$cf{imgdir}/$no-s-4$ex4");
				}
				if ($e5n && $e5n ne $ex5) {
					unlink("$cf{imgdir}/$no-5$ex5");
					unlink("$cf{imgdir}/$no-s-5$ex5") if (-f "$cf{imgdir}/$no-s-5$ex5");
				}
				if ($e6n && $e6n ne $ex6) {
					unlink("$cf{imgdir}/$no-6$ex6");
					unlink("$cf{imgdir}/$no-s-6$ex6") if (-f "$cf{imgdir}/$no-s-6$ex6");
				}

				# 画像差替
				if ($e1n) { $ex1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $ex2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $ex3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $ex4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $ex5 = $e5n; $w5 = $w5n; $h5 = $h5n; }
				if ($e6n) { $ex6 = $e6n; $w6 = $w6n; $h6 = $h6n; }

				$_ = "$no<>$dat<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$ex1<>$w1<>$h1<>$tim<>$chk<>$in{color}<>$in{color2}<>$ex2<>$w2<>$h2<>$ex3<>$w3<>$h3<>$ex4<>$w4<>$h4<>$ex5<>$w5<>$h5<>$ex6<>$w6<>$h6<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>$lock<>\n";
			}
			push(@log,$_);
		}
		seek(DAT,0,0);
		print DAT @log;
		truncate(DAT,tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事の修正を完了しました");

	# スレッドロック開閉
	} elsif ($in{mode_lock} && $in{no}) {

		# データオープン
		my @data;
		open(DAT,"+< $cf{datadir}/log.cgi") or cgi_err("open err: log.cgi");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$host,$pw,$ex1,$w1,$h1,$tim,$chk,$col,$col2,$ex2,$w2,$h2,$ex3,$w3,$h3,$ex4,$w4,$h4,$ex5,$w5,$h5,$ex6,$w6,$h6,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$lock) = split(/<>/);

			# スレッドロック開閉
			if ($in{no} == $no) {
				if ($lock == 0) { $lock = 1; } else { $lock = 0; }
				$_ = "$no<>$dat<>$nam<>$eml<>$sub<>$com<>$url<>$host<>$pw<>$ex1<>$w1<>$h1<>$tim<>$chk<>$col<>$col2<>$ex2<>$w2<>$h2<>$ex3<>$w3<>$h3<>$ex4<>$w4<>$h4<>$ex5<>$w5<>$h5<>$ex6<>$w6<>$h6<>$imgtxt1<>$imgtxt2<>$imgtxt3<>$imgtxt4<>$imgtxt5<>$imgtxt6<>$lock<>\n";
			}
			push(@data,$_);
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事のロック開閉を調整しました");
	
	# 画像許可
	} elsif ($in{mode_chk} && $in{no}) {
		my %chk;
		foreach ( $cgi->param('no') ) {
			$chk{$_}++;
		}
		
		# 削除情報をマッチング
		my @log;
		open(DAT,"+< $cf{datadir}/log.cgi") or cgi_err("open err: log.cgi");
		eval "flock(DAT,2);";
		while (<DAT>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$host,$pw,$ex1,$w1,$h1,$tim,$chk,$col,$col2,$ex2,$w2,$h2,$ex3,$w3,$h3,$ex4,$w4,$h4,$ex5,$w5,$h5,$ex6,$w6,$h6,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6) = split(/<>/);
			
			if (defined $chk{$no}) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$dat<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$ex1<>$w1<>$h1<>$tim<>$chk<>$in{color}<>$in{color2}<>$ex2<>$w2<>$h2<>$ex3<>$w3<>$h3<>$ex4<>$w4<>$h4<>$ex5<>$w5<>$h5<>$ex6<>$w6<>$h6<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>\n";
			}
			push(@log,$_);
		}
		seek(DAT,0,0);
		print DAT @log;
		truncate(DAT,tell(DAT));
		close(DAT);
	
	# 削除処理
	} elsif ($in{mode_del} && $in{no}) {
		my %del;
		foreach ( $cgi->param('no') ) {
			$del{$_}++;
		}
		
		# 削除情報をマッチング
		my @log;
		open(DAT,"+< $cf{datadir}/log.cgi") or cgi_err("open err: log.cgi");
		eval "flock(DAT,2);";
		while (<DAT>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$host,$pw,$ex1,$w1,$h1,$tim,$chk,$col,$col2,$ex2,$w2,$h2,$ex3,$w3,$h3,$ex4,$w4,$h4,$ex5,$w5,$h5,$ex6,$w6,$h6,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6) = split(/<>/);
			
			if (defined($del{$no})) {
				if ($ex1) {
					unlink("$cf{imgdir}/$no-1$ex1");
					unlink("$cf{imgdir}/$no-s-1$ex1") if (-f "$cf{imgdir}/$no-s-1$ex1");
				}
				if ($ex2) {
					unlink("$cf{imgdir}/$no-2$ex2");
					unlink("$cf{imgdir}/$no-s-2$ex2") if (-f "$cf{imgdir}/$no-s-2$ex2");
				}
				if ($ex3) {
					unlink("$cf{imgdir}/$no-3$ex3");
					unlink("$cf{imgdir}/$no-s-3$ex3") if (-f "$cf{imgdir}/$no-s-3$ex3");
				}
				if ($ex4) {
					unlink("$cf{imgdir}/$no-4$ex4");
					unlink("$cf{imgdir}/$no-s-4$ex4") if (-f "$cf{imgdir}/$no-s-4$ex4");
				}
				if ($ex5) {
					unlink("$cf{imgdir}/$no-5$ex5");
					unlink("$cf{imgdir}/$no-s-5$ex5") if (-f "$cf{imgdir}/$no-s-5$ex5");
				}
				if ($ex6) {
					unlink("$cf{imgdir}/$no-6$ex6");
					unlink("$cf{imgdir}/$no-s-6$ex6") if (-f "$cf{imgdir}/$no-s-6$ex6");
				}
					next;
			}
			push(@log,$_);
		}
		seek(DAT,0,0);
		print DAT @log;
		truncate(DAT,tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事を削除しました");

	}
	
	# 画面表示
	header("管理用画面");
	print <<"EOM";
<div id="main">
<div class="back-btn">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="&lt; メニュー">
</form>
</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="data_men" value="1">
<input type="submit" name="mode_edit" value="修正">
<input type="submit" name="mode_del" value="削除">
<input type="submit" name="mode_lock" value="ロック">
EOM

	if ($cf{imgcheck}) {
		print qq|<input type="submit" name="mode_chk" value="添付許可">\n|;
	}
	
	open(IN,"$cf{datadir}/log.cgi") or cgi_err("open err: log.cgi");
	while (<IN>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$host,$pw,$ex1,$w1,$h1,$tim,$chk,$col,$col2,$ex2,$w2,$h2,$ex3,$w3,$h3,$ex4,$w4,$h4,$ex5,$w5,$h5,$ex6,$w6,$h6,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$lock) = split(/<>/);
		if ($eml) { $nam = qq|<a href="mailto:$eml">$nam</a>|; }
			$com =~ s/\n/<br>/g;

		print qq|<div class="log"><input type="checkbox" name="no" value="$no">|;
		print qq|<strong>$sub</strong> 投稿者：<b>$nam</b> 投稿日：$dat No.$no &lt;<span>$host</span>&gt;|;

		if ($lock == 1) {
			print qq|<img src="cmn/lock02s.png" height="24px" class="clip" alt="" />&nbsp;&nbsp;|;
		}

		#print qq|<div class="com">| . cut_str($com,50) . qq|</div>\n|;
		print qq|<div class="com">$com</div>\n|;

		
		if ($ex1) {
			my $size = get_size("$cf{imgdir}/$no-1$ex1");
			print qq|[<a href="$cf{imgdir}/$no-1$ex1" target="_blank">添付</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
			print qq|($size) &nbsp;&nbsp;\n|;
				if ($imgtxt1 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;<br>\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt1)</span> &nbsp;<br>\n|;
				}
		}
		if ($ex2) {
			my $size = get_size("$cf{imgdir}/$no-2$ex2");
			print qq|[<a href="$cf{imgdir}/$no-2$ex2" target="_blank">追加添付 1</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
			print qq|($size) &nbsp;&nbsp;\n|;
				if ($imgtxt2 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt2)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($ex3) {
			my $size = get_size("$cf{imgdir}/$no-3$ex3");
			print qq|[<a href="$cf{imgdir}/$no-3$ex3" target="_blank">追加添付 2</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
			print qq|($size) &nbsp;&nbsp;\n|;
				if ($imgtxt3 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt3)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($ex4) {
			my $size = get_size("$cf{imgdir}/$no-4$ex4");
			print qq|[<a href="$cf{imgdir}/$no-4$ex4" target="_blank">追加添付 3</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
			print qq|($size) &nbsp;&nbsp;\n|;
				if ($imgtxt4 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt4)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($ex5) {
			my $size = get_size("$cf{imgdir}/$no-4$ex4");
			print qq|[<a href="$cf{imgdir}/$no-4$ex4" target="_blank">追加添付 4</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
			print qq|($size) &nbsp;&nbsp;\n|;
				if ($imgtxt5 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt5)</span> &nbsp;&nbsp;\n|;
				}
		}
		if ($ex6) {
			my $size = get_size("$cf{imgdir}/$no-6$ex6");
			print qq|[<a href="$cf{imgdir}/$no-6$ex6" target="_blank">追加添付 5</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
			print qq|($size) &nbsp;&nbsp;\n|;
				if ($imgtxt6 eq '') {
					print qq|<span style="color:#d83473">(no title)</span> &nbsp;&nbsp;\n|;
				} else {
					print qq|<span style="color:#d83473">($imgtxt6)</span> &nbsp;&nbsp;\n|;
				}
		}
		print qq|</div>\n|;
	}
	close(IN);

		print qq|<div class="art-end"></div>\n|;
	
	print <<EOM;
</form>
</div></div>
</body>
</html>
EOM

	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  編集フォーム
#-----------------------------------------------------------
sub edit_form {
	my $log = shift;
	my ($no,$dat,$nam,$eml,$sub,$com,$url,$host,$pw,$ex1,$w1,$h1,$tim,$chk,$col,$col2,$ex2,$w2,$h2,$ex3,$w3,$h3,$ex4,$w4,$h4,$ex5,$w5,$h5,$ex6,$w6,$h6,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$lock) = split(/<>/);
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';
	
	header('管理TOP &gt; 編集フォーム');
	print <<EOM;
<div id="main">
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="data_men" value="1">
<input type="submit" value="&lt; 前に戻る">
</form>
</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="data_men" value="1">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mode_edit2" value="1">
<input type="hidden" name="no" value="$in{no}">
<table class="edit-fm">
<tr>
	<th>なまえ</th>
	<td><input type="text" name="name" size="30" class="reg-name" value="$nam"></td>
</tr><tr>
	<th>e-mail</th>
	<td><input type="text" name="email" size="30" class="reg-eml" value="$eml"></td>
</tr><tr>
	<th>タイトル</th>
	<td><input type="text" name="sub" size="36" class="reg-ttl" value="$sub"></td>
</tr><tr>
	<th>コメント</th>
	<td><textarea name="comment" class="reg-com" rows="7">$com</textarea></td>
EOM

		print qq|</tr><tr>\n|;
		print qq|<th>添付</th><td>\n|;
	if ($ex1) {
		print qq|　　<input type="file" name="upfile1" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="40">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$no-1$ex1" target="_blank">添付</a>|;
		print qq|<input type="checkbox" name="del1" value="1">削除]<br />\n|;
	} else {
		print qq|　　<input type="file" name="upfile1" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="40"><br />\n|;
	}
	print <<EOM;
</tr><tr>
	<th>参照先</th>
	<td><input type="text" name="url" class="reg-url" value="$url"></td>
EOM

		print qq|</tr><tr>\n|;
		print qq|<th>追加添付</th><td>\n|;
	if ($ex2) {
		print qq|１．<input type="file" name="upfile2" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="40">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$no-2$ex2" target="_blank">追加添付１</a>|;
		print qq|<input type="checkbox" name="del2" value="1">削除]<br /><hr>\n|;
	} else {
		print qq|１．<input type="file" name="upfile2" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="40"><br /><hr><br />\n|;
	}

	if ($ex3) {
		print qq|２．<input type="file" name="upfile3" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="40">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$no-3$ex3" target="_blank">追加添付２</a>|;
		print qq|<input type="checkbox" name="del3" value="1">削除]<br /><hr>\n|;
	} else {
		print qq|２．<input type="file" name="upfile3" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="40"><br /><hr><br />\n|;
	}

	if ($ex4) {
		print qq|３．<input type="file" name="upfile4" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="40">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$no-4$ex4" target="_blank">追加添付３</a>|;
		print qq|<input type="checkbox" name="del4" value="1">削除]<br /><hr>\n|;
	} else {
		print qq|３．<input type="file" name="upfile4" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="40"><br /><hr><br />\n|;
	}

	if ($ex5) {
		print qq|４．<input type="file" name="upfile5" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="40">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$no-5$ex5" target="_blank">追加添付４</a>|;
		print qq|<input type="checkbox" name="del5" value="1">削除]<br /><hr>\n|;
	} else {
		print qq|４．<input type="file" name="upfile5" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="40"><br /><hr><br />\n|;
	}
	if ($ex6) {
		print qq|５．<input type="file" name="upfile6" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="40">&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{imgurl}/$no-6$ex6" target="_blank">追加添付５</a>|;
		print qq|<input type="checkbox" name="del6" value="1">削除]<br />\n|;
	} else {
		print qq|５．<input type="file" name="upfile6" size="36" />&nbsp;\n|;
		print qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="40"><br /><br />\n|;
	}
	print <<EOM;
</tr><tr>
	<th></th>
	<td><input type="submit" class="reg-btn" value="編集する"></td>
</tr>
</table>
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;
	
	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<link href="$cf{cmnurl}/admin.css" rel="stylesheet">
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<script type="text/javascript" src="./cmn/footerFixed_modified.js"></script>
<title>$ttl</title>
</head>
<body>
<div id="head">
	<div id="main-ttl">
		<h1>$cf{version} : 管理画面</h1>
	</div>
</div>
<div id="body">
EOM
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	header("完了");
	print <<EOM;
<div id="main">
<div id="main-in">
<div class="ta-c">

<hr width="350">
<p class="msg">$msg</p>
<hr width="350">

<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="data_men" value="1">
<input type="submit" value="記事管理画面に戻る">
</form>

</div>

</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub cgi_err {
	my $err = shift;
	
	header("ERROR!");
	print <<EOM;
<div class="ta-c">
<div id="err">
<h3>ERROR!</h3>
<p class="err">$err</p>
<p><input type="button" value="前画面に戻る" onclick="history.back()"></p>
</div>
</div>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
	- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
	++ <a href="http://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  件名文字カット for UTF-8
#-----------------------------------------------------------
sub cut_str {
	my ($str,$all) = @_;
	$str =~ s|<br( /)?>||g;
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	
	my $i = 0;
	my $ret;
	while ($str =~ /($byte1|$byte2|$byte3|$byte4)/gx) {
		$i++;
		$ret .= $1;
		last if ($i >= $all);
	}
	return $ret;
}

