# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ CLIP BOARD : init.cgi - 2022/05/28
#│ copyright (c) kentweb, 1997-2022
#│ https://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'ClipBoard v6.21';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このプログラムはフリーソフトです。このプログラムを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  ClipBoard v6.21 com-multi v2.0 : init.cgi - 2023/10/17
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
#
#===========================================================
# ■ 基本設定
#===========================================================

# パスワード制限をする場合入室パスワード設定
# → 空欄の場合はパスワード制限なし
$cf{enter_pwd} = '0123';

# パスワード制限時のセッションの許容時間（分単位）
# → 入室後からアクセス可能時間
$cf{sestime} = 60;

# 投稿用パスワード
# → 空欄の場合はパスワード制限なし
$cf{usr_password} = '';

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 1;

# 掲示板タイトル
$cf{bbs_title} = 'ClipBoard v6.21 com-multi v2.0';

# 本体プログラムURL【URLパス】
$cf{bbs_cgi} = './clipbbs.cgi';

# 投稿プログラムURL【URLパス】
$cf{regist_cgi} = './regist.cgi';

# 管理プログラムURL【URLパス】
$cf{admin_cgi} = './admin.cgi';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# 最大記事数
# → これを超える記事は古い順に削除されます
$cf{maxlog} = 100;

# 戻り先【URLパス】
$cf{homepage} = "../index.html";

# URL自動リンク
# → 0=no 1=yes
$cf{autolink} = 1;

# １ページあたりの記事表示件数
# → 順に、スレッド表示、アルバム表示
$cf{pg_max} = 10;
$cf{max_albums} = 6;

# アップロードディレクトリ【サーバパス】
$cf{imgdir} = "./img";

# アップロードディレクトリ【URLパス】
$cf{imgurl} = "./img";

# アイコンディレクトリ【URLパス】
$cf{iconurl} = './cmn/icon';

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = "./tmpl";

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# セッションファイル【サーバパス】
$cf{sesfile} = './data/ses.cgi';

# YouTubeを表示する
$cf{tube} = 1;

# 文字色の設定
# →　スペースで区切る
$cf{colors} = '#000000 #666666 #6c2463 #a688bd #98605e #ea5550 #ea618e #ed6d46 #ffdc00 #f39800 #79c06e #387d39 #80B3DE #398ED9 #8d93c8';

# Ribbon Color{枠色}の設定（半角スペースで区切る）
$cf{colors_b} = '#2ca9e1 #007bbb #8d93c8 #3e62ad #706caa #e17b34 #e6b422 #e5a323 #e9bc00 #f39800 #79c06e #417038 #5f6527 #98605e #941f57 #ea5550 #ef857d #47266e #a688bd #6c2463 #da81b2 #f3a68c #e95464 #e3acae #898989';

$cf{colors_b2}= '天色 紺碧 ウイスタリア 杜若色 藤納戸 ローシェンナ ゴールド パンプキン トパーズ マリーゴールド スペアミント スピナッチグリーン オリーブグリーン ココアブラウン クラレット レッド コーラルレッド ディープロイヤルパープル ラベンダーモーブ プラム オーキッドピンク サーモンピンク ローズ ピンクアーモンド バトルシップグレイ';

#------------------------------------------------------------#

# 追加添付ファイル入力フォーム数最大値
$cf{add_usermax} = 5;

# 追加添付ファイル入力フォーム数（MAX=5）
# 最大追加数は５です。５以上はアップロード不可。
# ex. ５の場合は[0,1,2,3,4,5]、または[0,1,3,5]などに変更。
$cf{addattach} = [0,1,2,3,4,5];

# 追加添付ファイル入力フォーム数の初期値
# 閲覧者が初めてこの掲示板を開いた時に見る入力フォームの行数です。
# 変更可能な数値は「0～5」までの数値です。初期数値は「1」に設定されています。
$cf{attach_defo} = 1;

# 入力フォーム数変更後戻るアドレス【URLパス】
# ここは変更しないで下さい！
$cf{checge_url} = './clipbbs.cgi?mode=form';

# -------------------------------------------------------------- #
# [ ココから「コメント返信」機能関連の設定 ]
#
# コメント返信機能ON/OFF
# → 0=no  1=yes
$cf{comment} = 1;

# コメント承認制 (0=no 1=yes)
# → 投稿記事を管理者が表示前に確認する場合（スパム対策）
$cf{approve} = 0;

# コメント返信採番ファイル【サーバパス】
$cf{resnum} = './data/resno.dat';

# TOP用採番ファイル【サーバパス】
$cf{rescnt} = './data/res_cnt.dat';

# コメント返信ログファイル名【サーバパス】
$cf{reslog} = './data/reslog.cgi';

# 最大コメント数 
# サンプルのため、少なく設定されているので、必ず修正する事！
$cf{max_res} = 5;

# アップロードディレクトリ【サーバパス】
$cf{r_upldir} = "./resupl";

# アップロードディレクトリ【URLパス】
$cf{r_uplurl} = "./resupl";

# コメント返信：画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{r_max_img_w} = 200;	# 横幅
$cf{r_max_img_h} = 120;	# 縦幅

# コメント返信暗証キー入力フォーム：画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{pw_max_img_w} = 80;	# 横幅
$cf{pw_max_img_h} = 55;	# 縦幅

# １ページあたりの記事表示件数
# → 順に、アルバム表示、コメント検索
$cf{max_resalbum} = 8;
$cf{max_resfind} = 5;

# コメント返信メール通知機能
# → 0=no  1=yes
$cf{res_mailing} = 1;

# メール通知先アドレス（メール通知する場合）
$cf{mailto_r} = 'xxx@xxxx.xxx';

# アイコン画像【URLパス】
# → [コメントアイコン]
$cf{ico_com} = "./cmn/icon/comment.png";

# コメント禁止ワードチェック
# → 投稿時禁止するワードをコンマで区切る
$cf{bad_word} = '';

# コメント日本語チェック（コメント内に日本語が含まれていなければ拒否）
# 0=no  1=yes
$cf{jp_word_chk} = 1;

# コメントアクセス制限（半角スペースで区切る、アスタリスク可）
# → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{bad_host} = '';

# コメント承認ログディレクトリ【サーバパス】
$cf{logdir} = './data/approve';

# -------------------------------------------------------------- #
# [ ココまで「コメント返信」機能関連の設定 ]

# アップファイル管理者チェック機能
# → アップされた添付ファイルは管理者がチェック後に表示
# 0=no 1=yes
$cf{imgcheck} = 0;

# メール通知機能
# → 0=no  1=yes
$cf{mailing} = 0;

# メール通知先アドレス（メール通知する場合）
$cf{mailto} = 'xxx@xxx.xx';

# sendmailのパス（メール通知する場合）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# アクセス制限（半角スペースで区切る、アスタリスク可）
# → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
# → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '';

# 同一ホストからの連続投稿を制限（秒数で指定）
# → 秒数を記述するとその時間以上を経過しないと連続投稿できない
$cf{w_regist} = 60;

# 禁止ワード
# → 投稿時禁止するワードをコンマで区切る
$cf{no_wd} = '';

# 日本語チェック（コメント内に日本語が含まれていなければ拒否）
# 0=no  1=yes
$cf{jp_wd} = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 2;

# 投稿受理最大サイズ (bytes)
# → 例 : 102400 = 100KB
$cf{maxdata} = 512000000;

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 250;	# 横幅
$cf{max_img_h} = 150;	# 縦幅

# アルバムサムネイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{alb_img_w} = 180;
$cf{alb_img_h} = 108;

# 画像と記事の位置
#  1 : 画像が下。記事は画像の上に表示。
#  2 : 画像が左。記事は右から回り込む。
$cf{imgpoint} = 2;

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 0;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_png}   = 1;  # PNG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 1;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 1;  # PDF
$cf{ok_mp3}   = 1;  # mp3
$cf{ok_mp4}   = 1;  # MP4

# アイコン定義
# → 拡張子とファイル名のペア
$cf{icons} = {
	'.pdf'  => 'pdf.png',
	'.doc'  => 'word.png',
	'.docx' => 'Word-icon.png',
	'.xls'  => 'excel.png',
	'.xlsx' => 'Excel-icon.png',
	'.ppt'  => 'ppt.png',
	'.pptx' => 'powerpoint.png',
	'.txt'  => 'text.png',
	'.zip'  => 'zip.png',
	'.mp3'  => 'mp3.png',
	'.mp4'  => 'mp4.png',
	};

# 添付ファイルアイコンディレクトリ【URLパス】
$cf{icourl} = './cmn/ico';

# クッキーID名（特に変更しなくてよい）
# → クッキー保存名
$cf{cookie_id} = "clipboard";
$cf{cookie_id2} = "clipref";
$cf{cookie_id3} = "clip_pwd";

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「過去ログ」機能を使用する場合の設定 ]

# 過去ログ生成
# → 0=no 1=yes
$cf{pastkey} = 1;

# 過去ログ用NOファイル【サーバパス】
$cf{nofile}  = './data/pastno.dat';

# 過去ログのディレクトリ【サーバパス】
# → パスの最後に / をつけない
$cf{pastdir} = './data/past';

# １ページあたりの記事表示件数
$cf{pg_maxp} = 3;

# 過去ログ１ファイルの行数
# → この行数を超えると次ページを自動生成します
$cf{pastmax} = 600;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能（スパム対策）を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 2;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captclipbbs';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "stamp.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# 設定内容を返す
sub set_init { return %cf; }

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if (!/^upfile\d$/) {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行処理
			$val =~ s|\r\n|<br />|g;
			$val =~ s|[\r\n]|<br />|g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;
	
	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('',<IN>);
	close(IN);
	
	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!(cmnurl|bbs_title)!/$cf{$1}/g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;
	
	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	
	return ($w,$h);
}

#-----------------------------------------------------------
#  コメント返信：画像リサイズ
#-----------------------------------------------------------
sub resize_res {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{r_max_img_w} || $h > $cf{r_max_img_h}) {
		my $w2 = $cf{r_max_img_w} / $w;
		my $h2 = $cf{r_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  コメント返信暗証キー入力フォーム：画像リサイズ
#-----------------------------------------------------------
sub resize_pwd {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{pw_max_img_w} || $h > $cf{pw_max_img_h}) {
		my $w2 = $cf{pw_max_img_w} / $w;
		my $h2 = $cf{pw_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  アルバム画像リサイズ
#-----------------------------------------------------------
sub alb_resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{alb_img_w} || $h > $cf{alb_img_h}) {
		my $w2 = $cf{alb_img_w} / $w;
		my $h2 = $cf{alb_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

#-----------------------------------------------------------
#  パスワード制限
#-----------------------------------------------------------
sub passwd {
	my %in = @_;

	# 入室フォーム指定のとき
	if ($in{mode} eq 'enter') { &pwd_form; }

	# 時間取得
	my $now = time;

	# ログインのとき
	if ($in{login}) {
		# 認証
		if ($in{pw} ne $cf{enter_pwd}) { &error("認証できません"); }

		# セッション発行
		my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z', '_');
		my $ses;
		srand;
		for (1 .. 25) {	$ses .= $wd[int(rand(@wd))]; }

		# セッション更新
		my @log;
		open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
		eval 'flock(DAT, 2);';
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			next if ($now - $time > $cf{sestime} * 60);

			push(@log,"$_\n");
		}
		unshift(@log,"$ses\t$now\n");
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# クッキー格納
		print "Set-Cookie: $cf{cookie_id3}=$ses\n";

	# セッション確認
	} else {

		# クッキー取得
		my $cook = $ENV{HTTP_COOKIE};

		# 該当IDを取り出す
		my %cook;
		foreach ( split(/;/, $cook) ) {
			my ($key,$val) = split(/=/);
			$key =~ s/\s//g;
			$cook{$key} = $val;
		}

		# クッキーなし
		if ($cook{$cf{cookie_id3}} eq '') { &pwd_form; }

		# ログオフのとき
		if ($in{mode} eq 'logoff') {

			my @log;
			open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
			eval 'flock(DAT, 2);';
			while(<DAT>) {
				my ($id,undef) = split(/\t/);
				next if ($cook{$cf{cookie_id3}} eq $id);

				push(@log,$_);
			}
			seek(DAT, 0, 0);
			print DAT @log;
			truncate(DAT, tell(DAT));
			close(DAT);

			if ($ENV{PERLXS} eq "PerlIS") {
				print "HTTP/1.0 302 Temporary Redirection\r\n";
				print "Content-type: text/html\n";
			}
			print "Set-Cookie: $cf{cookie_id3}=;\n";
			print "Location: $cf{homepage}\n\n";
			exit;
		}

		# セッションチェック
		my $flg;
		open(DAT,"$cf{sesfile}") or error("open err: $cf{sesfile}");
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);

			if ($cook{$cf{cookie_id3}} eq $id) {
				# 時間オーバー
				if ($now - $time > $cf{sestime} * 60) {
					$flg = -1;
				# OK
				} else {
					$flg = 1;
				}
				last;
			}
		}
		close(DAT);

		# 時間オーバー
		if ($flg == -1) {
			my $msg = qq|入室時間が経過しました。再度ログインしてください<br>\n|;
			$msg .= qq|[<a href="$cf{bbs_cgi}?mode=enter">ログイン</a>]\n|;
			&error($msg);

		# セッション情報なし
		} elsif (!$flg) {
			&pwd_form;
		}
	}
}

#-----------------------------------------------------------
#  投稿用パスワード制限
#-----------------------------------------------------------
sub passwd2 {
	my %in = @_;

	# パスワードが未入力の場合は入力フォーム画面
	if ($in{pass} eq "") {
		&post_form;

	# パスワード認証
	} elsif ($in{pass} ne $cf{usr_password}) {
		&error("認証できません");
	}
}

#-----------------------------------------------------------
#  投稿用パスワード入力フォーム
#-----------------------------------------------------------
sub post_form {

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/pass_form.html") or error("open err: pass_form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;

}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub pwd_form {
	open(IN,"$cf{tmpldir}/enter.html") or error('open err: enter.html');
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/clip.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/clip-mobile.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	footer($tmpl);
}

1;

